
#define PPM_Pin 3
int ppm[7]={0,0,0,0,0,0,0};  

void setup()
{
  Serial.begin(57600);
  Serial.println("ready");
  
  pinMode(PPM_Pin, INPUT);
  attachInterrupt(PPM_Pin - 2, read_ppm, CHANGE);
  
  TCCR1A = 0x00;	   // COM1A1=0, COM1A0=0 => Déconnecte le Pin OC1 du Timer/Counter 1 -- PWM11=0,PWM10=0 => PWM Operation disabled
  TCCR1B = B00000010;     //0x02;	   // 16MHz clock with prescaler means TCNT1 increments every .5 uS (cs11 bit set
  TIMSK1 = _BV(ICIE1);   // Permet la capture de l'interruption du Timer1
}

void read_ppm(){
  static unsigned int pulse;
  static unsigned long counter;
  static byte channel;

  counter = TCNT1;
  TCNT1 = 0;

  if(counter < 1020){  //doit être une impulsion
    pulse = counter;
  }
  else if(counter > 3820){  //synchro
    channel = 0;
  }
  else{  //On stocke la valeur de l'impulsion servo entre 810 et 2210 
    ppm[channel] = (counter + pulse)/2;
    channel++;
  }
}

void loop()
{
  
  static int count;

  while(ppm[count] != 0){  //
    Serial.print(ppm[count]);
    Serial.print("  ");
    count++;
  }
  count = 0;
  Serial.println("");
  delay(100);  
}

